#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/sysctl.h>
#include <mach/mach_time.h>

int tbmib[2] = { CTL_HW, HW_TB_FREQ } ;

long myround(double u)
{
  long result = u;
  while (result + 0.5 < u) result += 1;
  while (result - 0.5 > u) result -= 1;
  return result;
}

long doit(char **argv)
{
  char *p;
  double cpufrequency = 0;
  unsigned int tbfrequency = 0;
  size_t tbfrequencylen = sizeof(unsigned int);

  if (!argv[0]) return 0;
  if (!argv[1]) return 0;
  p = argv[1];
  cpufrequency = strtod(p,&p) * 1000000.0;
  if (cpufrequency <= 0) return 0;
  sysctl(tbmib,2,&tbfrequency,&tbfrequencylen,0,0);
  if (tbfrequency <= 0) return 0;
  return myround(cpufrequency / (double) (unsigned long long) tbfrequency);
}

main(int argc,char **argv)
{
  long tbcycles = doit(argv);
  if (tbcycles > 0) {
    printf("#define PPC_CLOCKS_PER_TICK %ld\n",tbcycles);
    return 0;
  }
  printf("#define PPC_CLOCKS_PER_TICK 16\n");
  return 100;
}
